/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_CICLO                                                    */
/* Tabela : CICLO                                                             */
/*                                                                            */
/* Criao:                                                                   */
/* 02/09/2004 - Henrique Dias Borges                                          */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_CICLO
BEFORE INSERT OR UPDATE OR DELETE
ON CICLO FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUCICL := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDCICLO,0) <> NVL(:NEW.CDCICLO,0)) OR
         (NVL(:OLD.IDCICLO,0) <> NVL(:NEW.IDCICLO,0)) OR
         (NVL(:OLD.NRCORCICLO,0) <> NVL(:NEW.NRCORCICLO,0)) THEN
         :NEW.DTULTATUCICL := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('CICLO', '', 'CDCICLO='||:OLD.CDCICLO||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE CICLO MODIFY DTULTATUCICL DEFAULT SYSDATE
/

